#include "stdafx.h"
#include "Test_ScrollBar.h"
#include "Test_ScrollBarDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

const int m_nLineSize = 15;
const int m_nBasic = 95;
const int m_nRepeat = 10;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

// Դϴ.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTest_ScrollBarDlg ȭ 




CTest_ScrollBarDlg::CTest_ScrollBarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest_ScrollBarDlg::IDD, pParent)
	, m_nEditX(80)
	, m_nEditY(80)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest_ScrollBarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_nEditX);
	DDX_Text(pDX, IDC_EDIT2, m_nEditY);
	DDX_Control(pDX, IDC_PCC_USERAREA, m_ctrl_PCT_Userarea);
}

BEGIN_MESSAGE_MAP(CTest_ScrollBarDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_BUTTON1, &CTest_ScrollBarDlg::OnBnClickedButton1)
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


// CTest_ScrollBarDlg ޽ ó

BOOL CTest_ScrollBarDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ý ޴ "..." ޴ ׸ ߰մϴ.

	// IDM_ABOUTBOX ý   ־ մϴ.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	InitObj();

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CTest_ScrollBarDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CTest_ScrollBarDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CTest_ScrollBarDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTest_ScrollBarDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int delta;

	switch(nSBCode)
	{
	case SB_LINEUP:
		delta = -m_nBasic;
		break;
	case SB_PAGEUP:
		delta = -VPageSize_;
		break;
	case SB_THUMBTRACK:
		delta = static_cast<int>(nPos) - VScrollPos_;
		break;
	case SB_PAGEDOWN:
		delta = VPageSize_;
		break;
	case SB_LINEDOWN:
		delta = m_nBasic;
		break;
	default:
		return;
	}

	int scrollpos = VScrollPos_ + delta;
	int maxpos = ViewHeight_ - VPageSize_;
	if (scrollpos < 0)
		delta = -VScrollPos_;
	else
		if(scrollpos > maxpos)
			delta = maxpos - VScrollPos_;

	if(delta != 0)
	{
		VScrollPos_ += delta;
		SetScrollPos(SB_VERT, VScrollPos_, TRUE);
		ScrollWindow(0, -delta);
	}
}

void CTest_ScrollBarDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	m_nHdelta = 0;

	switch(nSBCode)
	{
	case SB_LINELEFT:
		m_nHdelta = -m_nBasic;
		break;
	case SB_PAGELEFT:
		m_nHdelta = -HPageSize_;
		break;
	case SB_THUMBTRACK:
		m_nHdelta = static_cast<int>(nPos) - HScrollPos_;
		break;
	case SB_PAGERIGHT:
		m_nHdelta = HPageSize_;
		break;
	case SB_LINERIGHT:
		m_nHdelta = m_nBasic;
		break;
	default:
		return;
	}

	int scrollpos = HScrollPos_ + m_nHdelta;
	int maxpos = ViewWidth_ - HPageSize_;

	if( scrollpos < 0)
		m_nHdelta = -HScrollPos_;
	else
		if(scrollpos > maxpos)
			m_nHdelta = maxpos - HScrollPos_;

	if(m_nHdelta != 0)
	{
		HScrollPos_ += m_nHdelta;
		SetScrollPos(SB_HORZ, HScrollPos_,TRUE);
		ScrollWindow(-m_nHdelta, 0);
	}
}

void CTest_ScrollBarDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	CRect rect;
	GetDlgItem(IDC_PCC_USERAREA)->GetClientRect(rect);

	ViewWidth_ = rect.Width() + 45;
	ViewHeight_ = rect.Height() + 120;

	int HScrollMax = 0;
	HPageSize_ = 0;

	if(cx < ViewWidth_)
	{
		HScrollMax = ViewWidth_ - 1;
		HPageSize_ = cx;
		HScrollPos_ = min(HScrollPos_,ViewWidth_ - HPageSize_ - 1);
	}

	SCROLLINFO si;
	si.fMask = SIF_PAGE | SIF_RANGE | SIF_POS;
	si.nMin = 0;
	si.nMax = HScrollMax;
	si.nPos = HScrollPos_;
	si.nPage = HPageSize_;
	SetScrollInfo(SB_HORZ, &si, TRUE);

	int VScrollMax = 0;
	VPageSize_ = 0;

	if( cy < ViewHeight_)
	{
		VScrollMax = ViewHeight_ - 1;
		VPageSize_ = cy;
		VScrollPos_ = min(VScrollPos_,ViewHeight_ - VPageSize_ - 1);
	}

	si.fMask = SIF_RANGE | SIF_PAGE | SIF_POS;
	si.nMin = 0;
	si.nMax = VScrollMax;
	si.nPos = VScrollPos_;
	si.nPage = VPageSize_;
	SetScrollInfo(SB_VERT,&si,TRUE);
}

void CTest_ScrollBarDlg::InitObj()
{
	HScrollPos_ = 0;
	VScrollPos_ = 0;

// 	m_nEditX = 80;
// 	m_nEditY = 80;
}

void CTest_ScrollBarDlg::OnBnClickedButton1()
{
	UpdateData(TRUE);

	if(m_nEditX > 100 || m_nEditY > 100 || m_nEditX < 10 || m_nEditY < 10)
	{
		AfxMessageBox("10 ~ 100");
	}
	else
	{
		// ̾α ʱȭ
		InitObj();

		m_ctrl_PCT_Userarea.MoveWindow(m_nLineSize + 15, m_nLineSize * 6, GetPCWidth() * 15, GetPCHeight() * 15);
		TRACE("%d - %d\n", GetPCWidth(), GetPCHeight());


		// OnSize ȣ ũѹ 
		ShowScrollBar(SB_VERT, TRUE);
		ShowScrollBar(SB_HORZ, TRUE);

		CRect rc;
		GetDlgItem(IDC_PCC_USERAREA)->GetClientRect(rc);
		::SendMessage(this->m_hWnd, WM_SIZE, (WPARAM)SIZE_RESTORED, MAKELPARAM(rc.Width() + 45, rc.Height() + 120));
	}
}

BOOL CTest_ScrollBarDlg::OnEraseBkgnd(CDC* pDC)
{
	//return TRUE;

	return CDialog::OnEraseBkgnd(pDC);
}
